/* Copyright 2009 Palm, Inc.  All rights reserved. */

var RadioState = new Hash({wifi: undefined, bluetooth: undefined, phone: undefined});

var DevicemenuAssistant = Class.create({
	
	spinnerAttrs: {
		spinnerSize: 'small'
	},

	spinnerModel: {
		spinning: false
	},
	
	apSpinnerModel: {
		spinning: false
	},
	
	initialize: function(barAssistant,btProfileStatus) {
		this.barAssistant = barAssistant;
		this.btProfileStatus = btProfileStatus;	
		//this.barAssistant.setDeviceMenuAssistant(this);
	},
	
	setup: function() {
		
		//Add a touchable row class
		this.controller.get('palm-device-menu').addClassName('palm-touch-rows-'+Mojo.Environment.DeviceInfo.touchableRows);
			
		var date = new Date();
		this.controller.get('dm_date').innerHTML = Mojo.Format.formatDate(date,{date:'EEE '}) +  Mojo.Format.formatDate(date,{date:'long'});
						
		this.controller.setupWidget('brightSlider', {minValue: 0, maxValue: 100}, this.brightModel = { value: 50});

		this.modesModel = {scrollbars: false, mode: "vertical"},
		this.controller.setupWidget('devicescroller', {}, this.modesModel);
		this.menuscroller = this.controller.get('devicescroller');
		
		this.drawerModel = {myOpenProperty:false};
		this.controller.setupWidget('brightdetails', {modelProperty:'myOpenProperty'}, this.drawerModel);
		this.controller.setupWidget('wifidetails', {modelProperty:'myOpenProperty'}, this.drawerModel);
		this.controller.setupWidget('btdetails', {modelProperty:'myOpenProperty'}, this.drawerModel);
		this.controller.setupWidget('phonedetails', {modelProperty:'myOpenProperty'}, this.drawerModel);
		this.phonedrawer = this.controller.get('phonedetails')
		this.wifidrawer = this.controller.get('wifidetails');
		this.btdrawer = this.controller.get('btdetails');
		
		this.wifiListModel = {
			items: this.wifiAPList
        };     
	    this.controller.setupWidget('wifilist', 
									{itemTemplate:'devicemenu/listitem'}, 
									this.wifiListModel);				
		this.wifiListWidget = this.controller.get('wifilist');
		
		this.btListModel = {
			items: this.btdeviceList
		};
		this.controller.setupWidget('btlist', 
									{itemTemplate:'devicemenu/listitem'},
									this.btListModel);									
		this.btListWidget = this.controller.get('btlist');
		
		//Spinner for WiFi
		this.controller.setupWidget('wifiSpinner', this.spinnerAttrs, this.spinnerModel);
		
		//Spinner for Airplande Mode
		//this.controller.setupWidget('apSpinner', this.spinnerAttrs, this.apSpinnerModel);	    	
			
		this.controller.get('dm_airplanemode').style.display="none";
			
		var btstate = this.barAssistant.getCurrentBluetoothState();
		if(btstate === 'Off') {
			this.controller.get('btmsg').innerHTML = $L('Off');
			RadioState.set('bluetooth',false);
		}			
		else {
			RadioState.set('bluetooth',true);
					
			if(btstate === 'On')
				this.controller.get('btmsg').innerHTML = $L('On');
			else
				this.controller.get('btmsg').innerHTML = btstate.escapeHTML();			
		}			
			
		var wifistate = this.barAssistant.getCurrentWiFiState();
		if(wifistate === 'Off') {
			this.controller.get('wifimsg').innerHTML = $L('Off');
			RadioState.set('wifi',false);
		}			
		else {
			RadioState.set('wifi',true);	
			if(wifistate === 'On')
				this.controller.get('wifimsg').innerHTML = $L('On');
			else
				this.controller.get('wifimsg').innerHTML = wifistate.escapeHTML();			
		}		

		var phonestate = this.barAssistant.getCurrentPhoneState();
		if(phonestate === 'Off') {
			this.controller.get('phonemsg').innerHTML = $L('Off');
			RadioState.set('phone',false);
		}
		else {
			this.controller.get('phonemsg').innerHTML = $L('On');
			RadioState.set('phone',true);
		}

		this.controller.listen(this.controller.document, Mojo.Event.deactivate, this.close.bindAsEventListener(this));
		this.isVisible = true;
		
		//Hide WiFi Menu if WiFi is not present.
		if(!Mojo.Environment.DeviceInfo.wifiAvailable) {
			this.controller.get('dm_wifi').hide();
			this.controller.hideWidgetContainer(this.controller.get('dm_wifi'));
		}
		
		//set up the the menu div
		this.scrim = this.controller.sceneElement.querySelector('div[x-mojo-scrim]');
		this.systemmenu = this.controller.sceneElement.querySelector('div[x-mojo-dialog]');
		this.scrim.style.opacity = 0;
		this.systemmenuTop = this.systemmenu.offsetTop;
		this.systemmenu.style.top = (-1 * this.systemmenu.offsetHeight) + 'px';					
	},
	
	activate: function() {
		this.controller.get('brightSlider').addEventListener(Mojo.Event.propertyChange, this.handleBrightSlider.bindAsEventListener(this));
		this.controller.get('brightRow').addEventListener(Mojo.Event.tap, this.handleBrightTap.bindAsEventListener(this));
		this.controller.get('dm_airplanemode').addEventListener(Mojo.Event.tap, this.toggleAirplaneMode.bindAsEventListener(this));
		this.controller.get('wifilist').addEventListener(Mojo.Event.listTap,this.handleWiFiTap.bindAsEventListener(this));
		this.controller.get('btlist').addEventListener(Mojo.Event.listTap,this.handleBTTap.bindAsEventListener(this));		
		this.controller.get('dm_wifi').addEventListener(Mojo.Event.tap, this.togglewifiList.bindAsEventListener(this));
		this.controller.get('dm_bluetooth').addEventListener(Mojo.Event.tap, this.togglebluetoothList.bindAsEventListener(this));
		this.controller.get('dm_phone').addEventListener(Mojo.Event.tap, this.togglePhoneList.bindAsEventListener(this));
		this.controller.get('phone_radio').addEventListener(Mojo.Event.tap, this.togglePhoneRadio.bindAsEventListener(this));
		this.controller.get('wifi_radio').addEventListener(Mojo.Event.tap, this.toggleWifiRadio.bindAsEventListener(this));
		this.controller.get('bt_radio').addEventListener(Mojo.Event.tap, this.toggleBTRadio.bindAsEventListener(this));
		this.controller.get('dm_data').addEventListener(Mojo.Event.tap, this.toggleData.bindAsEventListener(this));
		this.controller.get('bt_pref').addEventListener(Mojo.Event.tap,this.handleBluetoothLaunch.bindAsEventListener(this));
		this.controller.get('wifi_pref').addEventListener(Mojo.Event.tap,this.handleWiFiLaunch.bindAsEventListener(this));
		this.controller.get('dm_gps').addEventListener(Mojo.Event.tap, this.toggleGPS.bindAsEventListener(this));
		this.controller.get('scrim').addEventListener(Mojo.Event.tap, this.toggleDeviceMenu.bindAsEventListener(this));
		this.controller.get('dm_roam').addEventListener(Mojo.Event.tap, this.toggleRoam.bindAsEventListener(this));
		//Close the App because this is a first launch.
		this.toggleDeviceMenu();						
	},	

	handleBrightTap: function(event) {
		this.controller.get('brightdetails').mojo.setOpenState(!this.controller.get('brightdetails').mojo.getOpenState());
	},

	handleBrightSlider: function(event) {
		this.controller.serviceRequest('palm://com.palm.display/control', {
			method: 'setProperty',
			parameters:{maximumBrightness:Math.round(event.value)}
		});
		this.controller.get('dm_brightness').innerText = "Brightness: " + Math.round(event.value) + "%";
	},
		
	cleanup: function() {
		Mojo.Log.error("Device Menu - Clean up called");				
	},	
			
	wifiAPList: [],
	btdeviceList: [],
		
	/*
	 * Toggles the AirplaneMode.
	 * 
	 * When Airplane Mode is enabled, it turns off the Phone. Also, it saves the current state of Bluetooth and WiFi and turn them off. 
	 * The Airplan Mode setting gets stored in the System Preferences.
	 */	 
	
	toggleAirplaneMode: function() {
		
		//Ignore the tap event if Airplane Mode is in Progress
		if(this.apModeInProgress)
			return;
		
		//this.apSpinnerModel.spinning = true;
		//this.controller.modelChanged(this.apSpinnerModel);	
				
		if(this.barAssistant.getAirplaneMode()) {
			Mojo.Log.info("SystemUI - Turning off Airplane Mode - Device Menu");
			this.barAssistant.setAirplaneMode(false);
			this.controller.get('dm_airplanemode_status').innerHTML = $L('Turning off Airplane Mode');			
		}			
		else {
			Mojo.Log.info("SystemUI - Turning on Airplane Mode - Device Menu");
			this.barAssistant.setAirplaneMode(true);
			this.controller.get('dm_airplanemode_status').innerHTML = $L('Turning on Airplane Mode');
		}
		this.apModeInProgress = true;
		this.toggleDeviceMenu.bind(this).delay(0.2);		
	},

	toggleGPS: function(event) {
		this.gpsEnabled = !this.gpsEnabled;
		this.controller.serviceRequest('palm://com.palm.location', {
			method: 'setUseGps',
			parameters: {
				useGps: this.gpsEnabled
			}
		});
		this.setGPSLabel();
	},

	setGPSLabel: function() {
		if(this.gpsEnabled) {
			this.controller.get('gpsStatus').innerText = "On";
		} else {
			this.controller.get('gpsStatus').innerText = "Off";
		}
	},
	
	updateAirplaneModeSettings: function() {
		
		//this.apSpinnerModel.spinning = false;
		//this.controller.modelChanged(this.apSpinnerModel);
		
		if(this.barAssistant.getAirplaneMode()) {
			this.controller.get('dm_airplanemode_status').innerHTML = $L('Turn off Airplane Mode');			
		}			
		else {			
			this.controller.get('dm_airplanemode_status').innerHTML = $L('Turn on Airplane Mode');
		}
		this.apModeInProgress = false;
	},


	updatePhone: function() {
		if(this.barAssistant.getCurrentPhoneState()) {
			this.controller.get('phonemsg').innerHTML = $L('On');
			this.controller.get('phone_radio').innerHTML = $L('Turn off Phone');
			RadioState.set('phone', true);
		}
		else {
			this.controller.get('phonemsg').innerHTML = $L('Off');
			this.controller.get('phone_radio').innerHTML = $L('Turn on Phone');
			RadioState.set('phone', false);
		}
	},

	togglePhoneRadio: function(event) {
		this.serviceRequest = new Mojo.Service.Request("palm://com.palm.vibrate", {
			method: 'vibrate', parameters: { 'period': 0,'duration': 250 }
		});
		if(RadioState.get('phone'))
			TelephonyService.tempPowerSet('off',false,null,null);
		else
			TelephonyService.tempPowerSet('on',false,null,null);
		this.toggleDeviceMenu();
	},

	togglePhoneList: function(event) {
		if(this.apModeInProgress)
			return;

		if (this.phonedrawer.mojo.getOpenState()) {
			this.controller.hideWidgetContainer(this.controller.get('phonedetails'));
		}
		else {
			if(RadioState.get('phone'))
				this.controller.get('phone_radio').innerHTML = $L('Turn off Phone');
			else
			this.controller.get('phone_radio').innerHTML = $L('Turn on Phone');

			this.controller.showWidgetContainer(this.controller.get('phonedetails'));
		}
		this.phonedrawer.mojo.setOpenState(!this.phonedrawer.mojo.getOpenState());
	},
	
	toggleBTRadio: function(event) {
		if(RadioState.get('bluetooth')) {
			BtService.radiooff(null,null);			
		}			
		else
			this.btRadioOnServiceReq = BtService.radioon(this.btRadioTurnedOn.bind(this),null);
		this.toggleDeviceMenu.bind(this).delay(0.2);		
	},
	
	btRadioTurnedOn: function(payload) {
		Mojo.Log.info("BT Radio "+ Object.toJSON(payload));
		if(payload.returnValue === true && !this.isBTPairedDeviceAvailable) {
			//Launch BT Pref App.
			this.launchBluetooth(false);
		}
	},
		
	/*
	 * Toggles the Bluetooth List to show and Hide when tapping on the Bluetooth Row.
	 */	
	togglebluetoothList: function(event) {
		
		//Ignore the tap event if Airplane Mode is in Progress
		if(this.apModeInProgress)
			return;
				
		this.clearBTList();
		if (this.btdrawer.mojo.getOpenState()) {			
			this.controller.get('btlist').hide();
			this.controller.hideWidgetContainer(this.controller.get('btdetails'));	
		}
		else {
			this.btTrustedListReq = BtService.getTrustedList(this.BtDevicesHandler.bind(this),this.BtDevicesHandler.bind(this));			
			if(RadioState.get('bluetooth')) {
				this.controller.get('bt_radio').innerHTML = $L('Turn off Bluetooth');
			}				
			else
				this.controller.get('bt_radio').innerHTML = $L('Turn on Bluetooth');	
					
			this.controller.get('btlist').show();
			this.controller.showWidgetContainer(this.controller.get('btdetails'));			
		}	
		this.btdrawer.mojo.setOpenState(!this.btdrawer.mojo.getOpenState());						
	},
	
	//Clear the Bluetooth List Array and List Model.	
	clearBTList: function() {		
		this.controller.get('btlist').hide();			
		this.btListWidget.mojo.noticeRemovedItems(0,this.btdeviceList.length);
		this.btdeviceList.clear();		
	},
	
	toggleRoam: function(event) {
		if(this.roamStatus == 'roamonly') {
			this.roamStatus = 'any';
		} else if(this.roamStatus == 'any') {
			this.roamStatus = 'homeonly';
		} else {
			this.roamStatus = 'roamonly';
		}
		this.controller.serviceRequest('palm://com.palm.telephony', {
			method: 'roamModeSet',
			parameters: {
				mode: this.roamStatus,
				client: Mojo.appName
			}
		});
		this.setRoamLabel();
	},

	setRoamLabel: function() {
		if(this.roamStatus=='roamonly') {
			this.controller.get('roamStatus').innerText = 'Always';
		} else if (this.roamStatus=="homeonly") {
			this.controller.get('roamStatus').innerText = 'Never';
		} else {
			this.controller.get('roamStatus').innerText = 'Automatic';
		}
	},

	/*
	 * Handles the Bluetooth Device connect or disconnect when tapped on the device.
	 */
	handleBTTap: function(event) {
		
		if(!event.item)
			return;
		
		var device = null;
		var deviceIndex = event.index;
		var devAddress = event.item.BT_ADDR;
				
		device = this.btdeviceList[deviceIndex];
			
		// Make sure the device was found
		if (!device)
			return;
		Mojo.log("Device Current State "+ device.CONNECTSTATE + " "+ device.DISPNAME);
		// There is a different action based on the current connect status of the device
		switch (device.CONNECTSTATE) {
			case 'connected':
				// Device is connected so disconnect all profiles it is connected on
				this.disconnectAllProfiles(devAddress);
				// Update the UI to reflect that it is no longer connected
				device.CONNECTSTATE = 'disconnected';
				device.showConnected = 'none';
				this.btListWidget.mojo.invalidateItems(deviceIndex,1);
				if(this.isVisible)
					this.toggleDeviceMenu();		
				break;
				
			case 'connecting':
				// Is this device waiting to connect?
				if (devAddress == this.pendingDevAddress) {
					// There is no longer a pending connection attempt to this device
					this.pendingDevAddress = null;
					this.pendingDevCOD = null;
				}
				else {
					// Abort the connection attempt on the supported profiles
					if (isHFGSupported(device.COD) && this.btProfileStatus['hfg'].status != 'disconnected') 
						this.disconnectProfile('hfg');
					if (isA2DPSupported(device.COD) && this.btProfileStatus['a2dp'].status != 'disconnected') 
						this.disconnectProfile('a2dp');
				}
	
				// Update the UI to reflect that it is no longer connecting
				device.CONNECTSTATE = 'disconnected';
				device.showConnected = 'none';	
				delete device.showErrorIfConnectFails;			
				this.btListWidget.mojo.invalidateItems(deviceIndex,1);
				break;
				
			case 'disconnected':
											
				// Is there a pending connection attempt to another device?
				if (this.pendingDevAddress && this.pendingDevAddress != devAddress) {
					// A connection to the previously pending device is no longer desired
					this.pendingDevAddress = null;
					this.pendingDevCOD = null;
					// Update the UI to reflect that there is no longer a pending connection attempt to the old device
					// Iterate through the list array to find out the index
					for (var i = 0; i < this.btdeviceList.length; i++) {
						if (this.btdeviceList[i].BT_ADDR == this.pendingDevAddress) {
							this.btdeviceList[i].CONNECTSTATE = 'disconnected';
							this.btdeviceList[i].showConnected = 'none';
							this.btListWidget.mojo.invalidateItems(i,1);
							break;
						}
					}
				}
							
				// The device the user tapped on must show "connecting"
				device.CONNECTSTATE = 'connecting';
				device.STATUS = $L('Connecting...');
				this.btListWidget.mojo.invalidateItems(deviceIndex,1);			
						
				// Iterate through the list and disconnect the audio profiles
				['hfg', 'a2dp'].each(function(profile) {
					if (this.btProfileStatus[profile].status != 'disconnected') {
						this.disconnectProfile(profile);
						// Make the connection attempt to this device pending.  The connection will
						// happen once the disconnect notification is received
						this.pendingDevAddress = devAddress;
						this.pendingDevCOD = device.COD;
						// Update the UI to reflect that it is no longer connected
						for (var i = 0; i < this.btdeviceList.length; i++) {
							if (this.btdeviceList[i].BT_ADDR == this.btProfileStatus[profile].address) {
								this.btdeviceList[i].CONNECTSTATE = 'disconnected';
								this.btdeviceList[i].showConnected = 'none';
								this.btListWidget.mojo.invalidateItems(i,1);								
								break;
							}
						}							
					}
				}.bind(this));
				
				// If the connection isn't pending then connect now
				if (!this.pendingDevAddress)
					this.connectAudio(devAddress,device.COD);
		}		
	},
	
	/*
	 * Bluetooth - Connects to the Audio Profiles.
	 */	
	connectAudio: function(devAddress,cod) {
		this.btConnectedDeviceAddr = null;
		// If HFG is supported then do associate and connect to that profile	
		if (isHFGSupported(cod)) {
			BtService.profAssociate(devAddress,'hfg',null,null);
			BtService.profConnect('hfg',null,null);			
		}
		else {
			BtService.profdisAssociate('hfg',null,null);
		}
		
		// If A2DP is supported then do associate and connect to that profile	
		if (isA2DPSupported(cod)) {
			BtService.profAssociate(devAddress,'a2dp',null,null);
			BtService.profConnect('a2dp',null,null);			
		}
		else {			
			BtService.profdisAssociate('a2dp',null,null);
		}
		
	},
	
	/*
	 * Disconnect All Bluetooth Profiles.
	 */	
	disconnectAllProfiles: function(devAddress) {
		 // Disconnect all profiles
		['hfg', 'a2dp'].each(function(profile) {
			if (this.btProfileStatus[profile] && this.btProfileStatus[profile].address == devAddress && this.btProfileStatus[profile].status != 'disconnected') {
				this.disconnectProfile(profile);
			}
		}.bind(this));	 
	},
	
	//Disconnects the given profile.		
	disconnectProfile: function(profile) {
		BtService.profDisconnect(profile);
	},
	
	/*
	 * Handler for Bluetooth gettrusteddevicelist service call.
	 */
			
	BtDevicesHandler: function(payload) {
		
		if(!payload)
			return;
		
		if (!RadioState.get('bluetooth') && payload.trusteddevices) {
			this.isBTPairedDeviceAvailable = payload.trusteddevices.length === 0 ? false : true;
			return;
		}
		
		for (var i = 0; i < payload.trusteddevices.length; i++) {			
			var device = {
				DISPNAME: payload.trusteddevices[i].name,
				CONNECTSTATE: payload.trusteddevices[i].status,
				BT_ADDR: payload.trusteddevices[i].address,
				COD: payload.trusteddevices[i].cod
			};
			
			if(isHFGSupported(payload.trusteddevices[i].cod) || isA2DPSupported(payload.trusteddevices[i].cod)) {
				if(payload.trusteddevices[i].status == 'connected') {
					device.showConnected = 'connected';	
					if (this.btProfileStatus['hfg'].status == "connected" && this.btProfileStatus['hfg'].address == payload.trusteddevices[i].address ||
					this.btProfileStatus['a2dp'].status == "connected" && this.btProfileStatus['a2dp'].address == payload.trusteddevices[i].address) 
						device.showConnected = 'connected';
					else {
						device.showConnected = 'none';
						device.CONNECTSTATE = 'disconnected';
					}				
				}					
				else {
					device.showConnected = 'none';					
				}				
				this.btdeviceList.push(device);
				var items = [device];
				this.btListWidget.mojo.noticeAddedItems(this.btListWidget.mojo.getLength(), items);							
			}		
		}			
	},
	
	/*
	 * Handles all Bluetooth Notification(Radio, Device Connect /Disconnect etc.
	 */
		
	bluetoothNotification: function(payload) {
			
		switch(payload.notification) {
			case 'notifnradioon':
				RadioState.set('bluetooth',true);
				//update the name displayed on the bluetooth row
				this.updateBluetooth('radio','On');
				break;
			case 'notifnradiooff':
				RadioState.set('bluetooth',false);
				//update the name displayed on the bluetooth row
				this.updateBluetooth('radio','Off');
				//Hide the bt list
				this.clearBTList();
				break;							
			case 'notifnconnecting':
				//Update the Name of the device on the bluetooth row
				if(payload.profile === 'hfg' || payload.profile === 'a2dp')
					this.updateBluetooth('device',payload.name);
				
				if(this.controller.get('btdetails').visible()) {
					for(var i = 0; i<this.btdeviceList.length;i++) {
						if(payload.address === this.btdeviceList[i].BT_ADDR) {							
							this.btdeviceList[i].STATUS = $L('Connecting...');
							this.btdeviceList[i].showErrorIfConnectFails = true;
							this.btListWidget.mojo.invalidateItems(i,1);
						}
					}
				}							
			    break;
			case 'notifndisconnecting':
				// Update the UI now
				if (this.controller.get('btdetails').visible()) {
					for (var i = 0; i < this.btdeviceList.length; i++) {
						if (payload.address === this.btdeviceList[i].BT_ADDR) {							
							this.btdeviceList[i].STATUS = '';
							this.btdeviceList[i].showConnected = 'none';							
							this.btListWidget.mojo.invalidateItems(i, 1);
						}
					}
				}			
				break;			
			case 'notifnconnected':	
				//Update the Name of the device on the bluetooth row
				if(payload.profile === 'hfg' || payload.profile === 'a2dp')
					this.updateBluetooth('device',payload.name);
				
				// Update the profile connected status
				if (payload.error == 0) {
					this.btConnectFailed = false;				
					// The device is connected, but if there is a pending connection to a
					// different device then disconnect this connection
					if (this.pendingDevAddress && this.pendingDevAddress != payload.address) {
						if (payload.profile == 'hfg' || payload.profile == 'a2dp') {
							this.disconnectProfile(payload.profile);
							break;
						}
					}					
					// Show the connected status on the UI			
					if(this.controller.get('btdetails').visible()) {
						for(var i = 0; i<this.btdeviceList.length;i++) {
							if(payload.address === this.btdeviceList[i].BT_ADDR) {
								this.btdeviceList[i].STATUS = '';
								this.btdeviceList[i].showConnected = 'connected';
								delete this.btdeviceList[i].showErrorIfConnectFails;								
								this.btListWidget.mojo.invalidateItems(i,1);
							}
						}
					}					
					if(this.isVisible && this.btConnectedDeviceAddr != payload.address)
						this.toggleDeviceMenu.bind(this).delay(1);	
					this.btConnectedDeviceAddr = payload.address;	
					break;
				}
				
				if (payload.alreadyconnectedaddr && this.controller.get('btdetails').visible()) {
					for(var i = 0; i<this.btdeviceList.length;i++) {
							if(payload.alreadyconnectedaddr === this.btdeviceList[i].BT_ADDR) {
								this.btdeviceList[i].STATUS = '';
								this.btdeviceList[i].showConnected = 'connected';
								delete this.btdeviceList[i].showErrorIfConnectFails;								
								this.btListWidget.mojo.invalidateItems(i,1);
							}
						}
				}
				
				// Intentional fall-through for connect error
			case 'notifndisconnected':
			
				// Update the UI now
				if (this.controller.get('btdetails').visible()) {
					for (var i = 0; i < this.btdeviceList.length; i++) {
						if (payload.address === this.btdeviceList[i].BT_ADDR) {
							if(this.btdeviceList[i].showErrorIfConnectFails && !this.pendingDevAddress)
								this.btdeviceList[i].STATUS = $L("Unable to connect");
							else
								this.btdeviceList[i].STATUS = '';
							this.btdeviceList[i].CONNECTSTATE = 'disconnected';
							this.btdeviceList[i].showConnected = 'none';
							this.btListWidget.mojo.invalidateItems(i, 1);
						}
					}
				}				
				// If there is a pending audio connection and this device is no longer
				// connected on a audio profile then connect to the pending device
				if (this.pendingDevAddress && this.isDeviceDisconnectedOnProfiles(payload.address, ['hfg', 'a2dp']))
				{
					this.connectAudio(this.pendingDevAddress, this.pendingDevCOD );
					this.pendingDevAddress = null;
					this.pendingDevCOD = null;			
				}
				
				// If the device is still connected on any profile then continue to show connected
				if (!this.isDeviceDisconnectedOnProfiles(payload.address, ['hfg', 'a2dp', 'pan']))
					break;
								
				//Update the Name of the device on the bluetooth row
				if(payload.profile === 'hfg' || payload.profile === 'a2dp') 
					this.updateBluetooth('device',undefined);
						
				break;
			case 'notifndevrenamed':
				if(this.isDeviceDisconnectedOnProfiles(payload.address, ['hfg', 'a2dp']))
					break;
				this.updateBluetooth('device',payload.name);
				break;			
		}
		
	},
	
	//Check to see if device is disconnected on a given profile.
	isDeviceDisconnectedOnProfiles: function(devAddress,profiles) {
		var disconnected = true;
	
		// Iterate through the specified profiles to see if the device is connected on that profile
		profiles.each(function(profile) {
			if (this.btProfileStatus[profile] && this.btProfileStatus[profile].address == devAddress && this.btProfileStatus[profile].status != "disconnected")
				disconnected = false;
		}.bind(this));
	
		return disconnected;
	},
	
	/*
	 * Update the Bluetooth Label to display the Radio State or Connected Device Name.
	 */
			
	updateBluetooth: function(updateElement,value) {
		
		if(updateElement === 'radio') {
			if(value === 'On') {
				this.controller.get('btmsg').innerHTML = $L('On');
				this.controller.get('bt_radio').innerHTML = $L('Turn off Bluetooth');					
				RadioState.set('bluetooth', true);
			}
			else {
				this.controller.get('btmsg').innerHTML = $L('Off');
				this.controller.get('bt_radio').innerHTML = $L('Turn on Bluetooth');
				RadioState.set('bluetooth', false);
				this.menuscroller.mojo.revealTop(0);
				this.clearBTList();
			}
		}
		else if(updateElement === 'device' && RadioState.get('bluetooth')) {
			if(value)
				this.controller.get('btmsg').innerHTML = value.escapeHTML();
			else
				this.controller.get('btmsg').innerHTML = $L('On');
		}
	},
	
	handleBluetoothLaunch: function(event) {
		this.launchBluetooth.bind(this).delay(0.2,true);
	},
	
	launchBluetooth: function(toggleMenu) {
		this.serviceRequest = new Mojo.Service.Request('palm://com.palm.applicationManager', {
				method: 'open',
				parameters: {'id': 'com.palm.app.bluetooth','params':{}}
		});
		if(toggleMenu)
			this.toggleDeviceMenu();
	},
	
	toggleWifiRadio: function(event) {
		if(RadioState.get('wifi')) {
			WiFiService.setState("disabled",null,null);	
			this.toggleDeviceMenu.bind(this).delay(0.2);			
		}			
		else {
			this.spinOn();
			WiFiService.setState("enabled",null,null);	
		}		
	},
	
	//Toggles the WiFi list to show or hide.		
	togglewifiList: function(event) {	
		
		//Ignore the tap event if Airplane Mode is in Progress
		if(this.apModeInProgress)
			return;
		
		this.clearWiFiList();
		if(this.wifidrawer.mojo.getOpenState()) {
			this.clearWiFiList();
			this.controller.get('wifilist').hide();
			this.controller.hideWidgetContainer(this.controller.get('wifidetails'));
		}
		else {
			if(RadioState.get('wifi')) {
				this.controller.get('wifi_radio').innerHTML = $L('Turn off Wi-Fi');
				this.spinOn();		
	
				this.wifiFindNetworksReq = WiFiService.findNetworks(this.wifiListCb.bind(this),this.wifiListCb.bind(this));
			}				
			else
				this.controller.get('wifi_radio').innerHTML = $L('Turn on Wi-Fi');	
					
			this.controller.get('wifilist').show();	
			this.controller.showWidgetContainer(this.controller.get('wifidetails'));	
		}		
		this.wifidrawer.mojo.setOpenState(!this.wifidrawer.mojo.getOpenState());						
	},
	
	/*
	 * Handler for Wifi Preference launch
	 */
	handleWiFiLaunch: function(event) {
		this.launchWifi.bind(this).delay(0.2);
	},
	
	//Clear the WiFi list array and list model.	
	clearWiFiList: function() {
		this.controller.get('wifilist').hide();			
		this.wifiAPList.clear();
		this.controller.modelChanged(this.wifiListModel, this);					
	},
	
	/*
	 * handles the connect to known profile when tapped on the list of accesspoints.
	 */	
	
	handleWiFiTap: function(event) {
				
		if(!event.item)
			return;
		
		var item = event.item;
		var itemIndex = event.index;
		var profile = this.wifiProfile(item);		
				
		if(item.CONNECTSTATE && item.CONNECTSTATE === 'connecting')
			return;
		else if(item.CONNECTSTATE && (item.CONNECTSTATE === 'ipConfigured' || item.CONNECTSTATE === 'associated' ||
										item.CONNECTSTATE === 'ipFailed' || item.CONNECTSTATE === 'associationFailed')) {
			//Launch WiFi Panel with Target Parameter.
			var appParams = {
          			  target: {ssid: item.NAME, securityType: item.securityType, profileId: item.PROFILE_ID, connectState: item.CONNECTSTATE},
                };
			this.launchWifi.bind(this,appParams).delay(0.2);					
		}
		else {
			if(item.PROFILE_ID) {
				this.wifiConnectReq = WiFiService.connect({"profileId": item.PROFILE_ID},null,null);
				item.CONNECTSTATE = 'connecting';
				item.STATUS = $L('Connecting...');
				item.showSelected = 'selected';
				this.wifiListWidget.mojo.invalidateItems(itemIndex,1);				
			}
			else {
				if(item.securityType) {
					//Launch WiFi Panel with Target Parameter.
					var appParams = {
          				  target: {ssid: item.NAME, securityType: item.securityType},
            	    };
					this.launchWifi.bind(this,appParams).delay(0.2);									
				}
				else {
					this.wifiConnectReq = WiFiService.connect(profile,null,null);
					item.CONNECTSTATE = 'connecting';
					item.STATUS = $L('Connecting...');
					item.showSelected = 'selected';
					this.wifiListWidget.mojo.invalidateItems(itemIndex,1);					
				}
			}
		}		
	},
	
	wifiProfile: function(networkInfo){
        var profile = {
            ssid: networkInfo.NAME,
            isAdHoc: networkInfo.isAdHoc,
            profileId: networkInfo.PROFILE_ID,
        };
        
        if (networkInfo.securityType) {
            profile.security = {
                securityType: networkInfo.securityType
            };
        };
        
        return profile;
    },
	
	/*
	 * Handles the WiFi Radio, Profile Connect and Disconnect Notifications.
	 */
	
	wifiNotification: function(updateElement,value) {
		
		var offset = -1;
		
		if(updateElement === 'service') {
			if(value === 'On') {
				RadioState.set('wifi', true);
				this.controller.get('wifimsg').innerHTML = $L('On');
				this.controller.get('wifi_radio').innerHTML = $L('Turn off Wi-Fi');
				if(this.wifidrawer.visible()) {
					this.wifiFindNetworksReq = WiFiService.findNetworks(this.wifiListCb.bind(this),this.wifiListCb.bind(this));
				}
			}
			else {
			 	this.controller.get('wifimsg').innerHTML = $L('Off');
				RadioState.set('wifi', false);
				this.menuscroller.mojo.revealTop(0);
				this.clearWiFiList();
			}
		}
		else if(updateElement === 'connection') {
			
			if(!value)
				return;
			this.controller.get('wifimsg').innerHTML = $L('On');
			RadioState.set('wifi', true);
			this.controller.get('wifi_radio').innerHTML = $L('Turn off Wi-Fi');
			switch(value.networkInfo.connectState) {
				case 'associated' :
				case 'associating': this.controller.get('wifimsg').innerHTML = value.networkInfo.ssid.escapeHTML();
									if(this.controller.get('wifilist').visible()) {
										var pos = 0;
										$A(this.wifiAPList).each(function(a){
            								if (a.NAME == value.networkInfo.ssid) {
               									 a.STATUS = $L('Connecting...');
												 a.connectState = 'Connecting';
												 a.showSelected = 'selected';
												 offset = pos;
            								}
											pos += 1;
       					 				});
									}
									break;
				case 'ipFailed':					
				case 'notAssociated': 
				case 'associationFailed': if(this.controller.get('wifilist').visible()) {
											var pos = 0;
											$A(this.wifiAPList).each(function(a){
												if (a.NAME == value.networkInfo.ssid) {
												 a.showConnected = 'none';
												 a.STATUS = '';	
												 a.showSelected = '';											
												 a.CONNECTSTATE = value.networkInfo.connectState;
												 if(value.networkInfo.connectState === 'associationFailed')
               									 	a.STATUS = $L('Association failed');
												 else if(value.networkInfo.connectState === 'ipFailed') {
												 	a.STATUS = $L('IP configuration failed');
													a.BOLD = 'bold';
												 }												 	
												 offset = pos;											
            									}
												pos += 1;
       					 					});
										   }
										   
										   if(RadioState.get('wifi'))
										   	this.controller.get('wifimsg').innerHTML = $L('On');
										   else
										   	this.controller.get('wifimsg').innerHTML = $L('Off');											
										  break;
				
				case 'ipConfigured': this.controller.get('wifimsg').innerHTML = value.networkInfo.ssid.escapeHTML();
									
									if(this.wifidrawer.mojo.getOpenState()) {
										var pos = 0;
										$A(this.wifiAPList).each(function(a){
            								if (a.NAME == value.networkInfo.ssid) {
               									 a.STATUS = '';
												 a.showConnected = 'connected';												 
												 a.CONNECTSTATE = value.networkInfo.connectState;
												 offset = pos;
            								}
											pos += 1;											
       					 				});
										
										var modelItem;
										// if found and not at the top remove it 
            							if (offset != -1 && offset != 0) {
											modelItem = this.wifiAPList[offset];
                							this.wifiAPList.splice(offset, offset);
            							}
            
            							// add it to the top if not already there.
            							if (offset != 0) {
             								this.wifiAPList.splice(0, 0, modelItem);
            							}										
									}
									this.controller.modelChanged(this.wifiListModel, this);
									this.menuscroller.mojo.revealTop(0);
									if(this.isVisible)
										this.toggleDeviceMenu.bind(this).delay(1);
									return;									
			}
			
		}
		if(offset != -1)
			this.wifiListWidget.mojo.invalidateItems(offset,1);				
	},
	
	/*
	 * Callback function for FindNetworks service call. It populates the list.
	 */
	
	wifiListCb: function(payload) {
		this.spinOff();
		if(!payload.returnValue)
			return;
		
		if(!this.controller.get('wifilist').visible())
			return;
		
		var list = payload.foundNetworks;
        if (!list || list.length == 0) {
            return;
        }
		
		for(var i = 0; i<list.length; i++) {
			
			if(!list[i].networkInfo.ssid)
				continue;
			var items = [];
			var accesspoint = {};
			
		 	if (list[i].networkInfo.ssid) {
				accesspoint.NAME = list[i].networkInfo.ssid;
				accesspoint.DISPNAME = list[i].networkInfo.ssid;
			}
			
			if(list[i].networkInfo.profileId)
				accesspoint.PROFILE_ID = list[i].networkInfo.profileId;
			
			if(list[i].networkInfo.signalBars)
				accesspoint.signalBars = list[i].networkInfo.signalBars;
			
			if (list[i].networkInfo.securityType) 
                accesspoint.securityType = list[i].networkInfo.securityType;
			
			accesspoint.showSelected = '';
            						
			if(list[i].networkInfo.connectState && (list[i].networkInfo.connectState == 'ipConfigured' || list[i].networkInfo.connectState == 'associated')) {
				accesspoint.showConnected = 'connected';				
				accesspoint.CONNECTSTATE = list[i].networkInfo.connectState;
				this.wifiAPList.push(accesspoint);
				items = [accesspoint];
				this.wifiListWidget.mojo.noticeAddedItems(this.wifiListWidget.mojo.getLength(), items);
								
			}
			else {//if(list[i].networkInfo.profileId || list[i].networkInfo.securityType == undefined){
				accesspoint.showConnected = 'none';				
				this.wifiAPList.push(accesspoint);
				items = [accesspoint];
				this.wifiListWidget.mojo.noticeAddedItems(this.wifiListWidget.mojo.getLength(), items);
								
			}									
		}
		this.menuscroller.mojo.validateScrollPosition();				
	},
	
	launchWifi: function(appParams) {
		var callParams = {
           				 id: 'com.palm.app.wifi',
            	         'params': appParams
        				};
		this.serviceRequest = new Mojo.Service.Request('palm://com.palm.applicationManager', {
				method: 'open',
				parameters: callParams
		});
		this.toggleDeviceMenu();
	},
	
	spinOn: function() {       
		this.spinnerModel.spinning = true;
		this.controller.modelChanged(this.spinnerModel);				
	},
	
	spinOff: function() {   
		this.spinnerModel.spinning = false;
		this.controller.modelChanged(this.spinnerModel);			
	},
	
	toggleData: function(event) {
		if(this.dataDisabled=="on") {
			this.dataDisabled = "off";
		} else {
			this.dataDisabled = "on";
		}
		this.controller.serviceRequest('palm://com.palm.wan', {
			method: 'set',
			parameters: {
				disablewan: this.dataDisabled
			}
		});
		this.setDataLabel();
	},

	setDataLabel: function() {
		if(this.dataDisabled=="off") {this.controller.get('dataStatus').innerText = "on";} else {this.controller.get('dataStatus').innerText = "off";}
	},

	close: function() {
		
		if(this.phonedrawer.mojo.getOpenState()) {
			this.controller.hideWidgetContainer(this.controller.get('phonedetails'));
			this.phonedrawer.mojo.setOpenState(false);
		}
		if (this.btdrawer.mojo.getOpenState()) {
			this.clearBTList();			
			this.controller.hideWidgetContainer(this.controller.get('btdetails'));
			this.btdrawer.mojo.setOpenState(false);	
		}		
		if(this.wifidrawer.mojo.getOpenState()) {
			this.clearWiFiList();
			this.controller.hideWidgetContainer(this.controller.get('wifidetails'));
			this.wifidrawer.mojo.setOpenState(false);
		}		
		this.controller.get('brightdetails').mojo.setOpenState(false);	
		//this.isVisible = false;
		if(this.isVisible){
			this.toggleDeviceMenu();
		}
		this.menuscroller.mojo.revealTop(0);
	},
	
	toggleDeviceMenu: function() {
		
		if(this.isVisible) {			
			this.isVisible = false;
			
			//animate the submenu onto the scene
			var animateScrim = function(){
				Mojo.Animation.animateStyle(this.scrim, 'opacity', 'bezier', {
							from: 0,
							to: 1,
							duration: .15,
							curve:'over-easy',
							reverse:true,
							styleSetter: function(element,value){
								element.style.opacity = value;
								}.curry(this.scrim).bind(this),
							onComplete: this.controller.stageController.deactivate.bind(this.controller.stageController)
						}
				);
			}

			Mojo.Animation.animateStyle(this.systemmenu, 'top', 'bezier', {
						from: this.systemmenuTop,
						to: (-1 * this.systemmenu.offsetHeight),
						duration: .15,
						curve:'ease-out',
						onComplete:animateScrim.bind(this)
					}
			);

			//this.controller.stageController.deactivate();
		}
		else {
			this.controller.serviceRequest('palm://com.palm.connectionmanager', {
				method: 'getstatus',
				parameters: {},
				onSuccess: function(response) {
					if(response.wan.state === "disconnected") {
						this.dataDisabled = "on";
					} else if(response.wan.state === "connected") {
						this.dataDisabled = "off";
					}
					this.setDataLabel();
				}.bind(this)
			});
			this.isVisible = true;
			this.controller.serviceRequest('palm://com.palm.telephony', {
				method: 'roamModeQuery',
				parameters: {},
				onSuccess: function(response) {
					this.roamStatus = response.extended.mode;
					this.setRoamLabel();
				}.bind(this)
			});
			var date = new Date();		
			this.controller.get('dm_date').innerHTML = Mojo.Format.formatDate(date,{date:'EEE '})  +  Mojo.Format.formatDate(date,{date:'long'});
			this.controller.serviceRequest('palm://com.palm.display/control', {
				method: 'getProperty',
				parameters:{properties:['maximumBrightness']},
				onSuccess: function(response) {
					if(response.maximumBrightness != undefined) {
						this.brightModel.value = parseInt(response.maximumBrightness);
						this.controller.modelChanged(this.brightModel);
						this.controller.get('dm_brightness').innerText = "Brightness: " + response.maximumBrightness + "%";
					} else {
						this.controller.get('dm_brightness').innerText = "Brightness: ??%";
					}
				}.bind(this)
			});

			this.controller.stageController.activate();
			
			var animateDialog = function(){
				Mojo.Animation.animateStyle(this.systemmenu, 'top', 'bezier', {
							from: (-1 * this.systemmenu.offsetHeight),
							to: this.systemmenuTop,
							duration: .15,
							curve:'ease-in'
						}
				);
			}
            
			this.controller.serviceRequest('palm://com.palm.location', {
				method: 'getUseGps',
				parameters: {},
				onSuccess: function(response) {
					this.gpsEnabled = response.useGps;
					this.setGPSLabel();
				}.bind(this)
			});

			//animate the scrim onto the scene and then the submenu
			Mojo.Animation.animateStyle(this.scrim, 'opacity', 'bezier', {
						from: 0,
						to: 1,
						duration: .15,
						curve:'over-easy',
						reverse:false,
						styleSetter: function(element,value){
							element.style.opacity = value;
							}.curry(this.scrim).bind(this),
						onComplete: animateDialog.bind(this)
					}
			);
		}		  
	},
	
	updateBatteryLevel: function(batlevel) {		
		var msg = $L("Battery: #{batlevel}");
		this.controller.get('dm_battery').innerHTML = new Template(msg).evaluate({
			"batlevel": Mojo.Format.formatPercent(batlevel)
		});		
	},
	
});
